local mod = ...



-- Building Asset Processor
mod:registerAssetProcessor("models/Security4.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Security5.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Security6.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Security7.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Security8.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Security9.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Assets -------------------------------------------------------------------------------------
mod:registerAssetId("models/Security4.fbx/Prefab/ConstableFemale.Hat.001", "PREFAB_SECURITY_CONSTABLEFEMALE_HAT1")
mod:registerAssetId("models/Security4.fbx/Prefab/ConstableMale.Hat.001", "PREFAB_SECURITY_CONSTABLEMALE_HAT1")
mod:registerAssetId("models/Security4.fbx/Prefab/ConstableFemale.Front.001", "PREFAB_SECURITY_CONSTABLEFEMALE_FRONT1")
mod:registerAssetId("models/Security4.fbx/Prefab/ConstableMale.Front.001", "PREFAB_SECURITY_CONSTABLEMALE_FRONT1")

mod:registerAssetId("models/Security4.fbx/Prefab/GuardMale.Front.001", "PREFAB_SECURITY_GUARDMALE_FRONT1")
mod:registerAssetId("models/Security4.fbx/Prefab/GuardMale.Front.002", "PREFAB_SECURITY_GUARDMALE_FRONT2")
mod:registerAssetId("models/Security4.fbx/Prefab/GuardMale.Front.003", "PREFAB_SECURITY_GUARDMALE_FRONT3")
mod:registerAssetId("models/Security4.fbx/Prefab/GuardMale.Hat.001", "PREFAB_SECURITY_GUARDMALE_HAT1")
mod:registerAssetId("models/Security4.fbx/Prefab/GuardMale.Hat.002", "PREFAB_SECURITY_GUARDMALE_HAT2")
mod:registerAssetId("models/Security4.fbx/Prefab/GuardFemale.Front.001", "PREFAB_SECURITY_GUARDFEMALE_FRONT1")
mod:registerAssetId("models/Security4.fbx/Prefab/GuardFemale.Front.002", "PREFAB_SECURITY_GUARDFEMALE_FRONT2")
mod:registerAssetId("models/Security4.fbx/Prefab/GuardFemale.Hat.001", "PREFAB_SECURITY_GUARDFEMALE_HAT1")
mod:registerAssetId("models/Security4.fbx/Prefab/GuardFemale.Hat.002", "PREFAB_SECURITY_GUARDFEMALE_HAT2")

mod:registerAssetId("models/Security4.fbx/Prefab/OutlawFemale.Front.001", "PREFAB_SECURITY_OUTLAWFEMALE_FRONT1")
mod:registerAssetId("models/Security4.fbx/Prefab/OutlawMale.Front.001", "PREFAB_SECURITY_OUTLAWMALE_FRONT1")
mod:registerAssetId("models/Security4.fbx/Prefab/OutlawStaff", "PREFAB_SECURITY_OUTLAW_STAFF")

mod:registerAssetId("models/Security4.fbx/Prefab/Bandit.Part.001", "PREFAB_SECURITY_BANDIT1")

mod:registerAssetId("models/Security4.fbx/Prefab/Constable.Part.000", "PREFAB_SECURITY_CONSTABLE0")
mod:registerAssetId("models/Security4.fbx/Prefab/Constable.Part.001", "PREFAB_SECURITY_CONSTABLE1")
mod:registerAssetId("models/Security4.fbx/Prefab/Constable.Part.002", "PREFAB_SECURITY_CONSTABLE2")
mod:registerAssetId("models/Security4.fbx/Prefab/Constable.Part.003", "PREFAB_SECURITY_CONSTABLE3")
mod:registerAssetId("models/Security4.fbx/Prefab/Constable.Part.004", "PREFAB_SECURITY_CONSTABLE4")
mod:registerAssetId("models/Security4.fbx/Prefab/Constable.Part.005", "PREFAB_SECURITY_CONSTABLE5")
mod:registerAssetId("models/Security4.fbx/Prefab/Constable.Part.006", "PREFAB_SECURITY_CONSTABLE6")
mod:registerAssetId("models/Security4.fbx/Prefab/Constable.Part.001/SmokeEmitter.000", "PREFAB_SECURITY_CONSTABLE1_SMOKE")
mod:registerAssetId("models/Security4.fbx/Prefab/Constable.Part.001.Constr", "PREFAB_SECURITY_CONSTABLE1_CONSTR")

mod:registerAssetId("models/Security4.fbx/Prefab/PatrolPoint", "PREFAB_SECURITY_PATROLPOINT")

mod:registerAssetId("models/Security4.fbx/Prefab/OutlawTheftPoint.001", "PREFAB_SECURITY_OUTLAWTHEFTPOINT1")
mod:registerAssetId("models/Security4.fbx/Prefab/OutlawTheftPoint.002", "PREFAB_SECURITY_OUTLAWTHEFTPOINT2")
mod:registerAssetId("models/Security4.fbx/Prefab/OutlawTheftPoint.003", "PREFAB_SECURITY_OUTLAWTHEFTPOINT3")

mod:registerAssetId("models/Security4.fbx/Prefab/OutlawCamp.001", "PREFAB_SECURITY_OUTLAWCAMP1")
mod:registerAssetId("models/Security4.fbx/Prefab/OutlawCamp.002", "PREFAB_SECURITY_OUTLAWCAMP2")
mod:registerAssetId("models/Security4.fbx/Prefab/OutlawCamp.001/OutlawPosition.001", "PREFAB_SECURITY_OUTLAWPOSITION1")
mod:registerAssetId("models/Security4.fbx/Prefab/OutlawCamp.001/OutlawPosition.002", "PREFAB_SECURITY_OUTLAWPOSITION2")
mod:registerAssetId("models/Security4.fbx/Prefab/OutlawCamp.001/OutlawPosition.003", "PREFAB_SECURITY_OUTLAWPOSITION3")
mod:registerAssetId("models/Security4.fbx/Prefab/OutlawCamp.001/OutlawPosition.004", "PREFAB_SECURITY_OUTLAWPOSITION4")
mod:registerAssetId("models/Security4.fbx/Prefab/OutlawCamp.001/OutlawPosition.005", "PREFAB_SECURITY_OUTLAWPOSITION5")
mod:registerAssetId("models/Security4.fbx/Prefab/OutlawCamp.Part", "PREFAB_SECURITY_OUTLAWCAMP")
mod:registerAssetId("models/Security4.fbx/Prefab/VillageCenter", "PREFAB_SECURITY_VILLAGECENTER")

mod:registerAssetId("models/Security4.fbx/Prefab/Pathfinder", "PREFAB_SECURITY_PATHFINDER")

mod:registerAssetId("models/Security4.fbx/Prefab/PointsGuard", "PREFAB_SECURITY_POINTS_GUARD")
mod:registerAssetId("models/Security4.fbx/Prefab/PointsVisual.Guard", "PREFAB_SECURITY_POINTSVISUAL_GUARD")
mod:registerAssetId("models/Security4.fbx/Prefab/PointsVisual.Constable", "PREFAB_SECURITY_POINTSVISUAL_CONSTABLE")
mod:registerAssetId("models/Security4.fbx/Prefab/PointsVisual.Tower", "PREFAB_SECURITY_POINTSVISUAL_TOWER")

mod:registerAssetId("models/Security4.fbx/Prefab/PointsBillboard.10", "PREFAB_SECURITY_POINTS_BILLBOARD10")
mod:registerAssetId("models/Security4.fbx/Prefab/PointsBillboard.5", "PREFAB_SECURITY_POINTS_BILLBOARD5")
mod:registerAssetId("models/Security4.fbx/Prefab/PointsBillboard.2", "PREFAB_SECURITY_POINTS_BILLBOARD2")

mod:registerAssetId("models/Security4.fbx/Prefab/PointsBillboard.Low", "PREFAB_SECURITY_POINTS_BILLBOARDLOW")
mod:registerAssetId("models/Security4.fbx/Prefab/PointsBillboard.Med", "PREFAB_SECURITY_POINTS_BILLBOARDMED")
mod:registerAssetId("models/Security4.fbx/Prefab/PointsBillboard.High", "PREFAB_SECURITY_POINTS_BILLBOARDHIGH")

mod:registerAssetId("models/Security4.fbx/Prefab/SoldierRally.Part", "PREFAB_SECURITY_RALLY")


mod:registerAssetId("models/Security5.fbx/Prefab/Tower.Part.Round.Root", "PREFAB_SECURITY_TOWER_ROUND_ROOT")
mod:registerAssetId("models/Security5.fbx/Prefab/Tower.Part.Square.Root", "PREFAB_SECURITY_TOWER_SQUARE_ROOT")
mod:registerAssetId("models/Security5.fbx/Prefab/Tower.Part.Tiling", "PREFAB_SECURITY_TOWER_TILING")

mod:registerAssetId("models/Security5.fbx/Prefab/Tower.Part.End.001", "PREFAB_SECURITY_TOWER1_END")
mod:registerAssetId("models/Security5.fbx/Prefab/Tower.Part.End.002", "PREFAB_SECURITY_TOWER2_END")
mod:registerAssetId("models/Security5.fbx/Prefab/Tower.Part.End.003", "PREFAB_SECURITY_TOWER3_END")
mod:registerAssetId("models/Security5.fbx/Prefab/Tower.Part.End.004", "PREFAB_SECURITY_TOWER4_END")
mod:registerAssetId("models/Security5.fbx/Prefab/Tower.Part.End.005", "PREFAB_SECURITY_TOWER5_END")
mod:registerAssetId("models/Security5.fbx/Prefab/Tower.Part.End.006", "PREFAB_SECURITY_TOWER6_END")

mod:registerAssetId("models/Security5.fbx/Prefab/Door.Part.000", "PREFAB_SECURITY_TOWER_DOOR0")
mod:registerAssetId("models/Security5.fbx/Prefab/Door.Part.001", "PREFAB_SECURITY_TOWER_DOOR1")
mod:registerAssetId("models/Security5.fbx/Prefab/Door.Part.002", "PREFAB_SECURITY_TOWER_DOOR2")

mod:registerAssetId("models/Security5.fbx/Prefab/Door.Part.004", "PREFAB_SECURITY_WALL_DOOR1")
mod:registerAssetId("models/Security5.fbx/Prefab/Banner.Part.001", "PREFAB_SECURITY_BANNER1")

mod:registerAssetId("models/Security5.fbx/Prefab/Window.Part.001", "PREFAB_SECURITY_TOWER_WINDOW1")
mod:registerAssetId("models/Security5.fbx/Prefab/Window.Part.002", "PREFAB_SECURITY_TOWER_WINDOW2")

mod:registerAssetId("models/Security6.fbx/Prefab/Wall.Part.End.001", "PREFAB_SECURITY_WALL_END")
mod:registerAssetId("models/Security6.fbx/Prefab/Wall.Part.Root", "PREFAB_SECURITY_WALL_ROOT")

mod:registerAssetId("models/Security7.fbx/Prefab/Gate.Part.End.001", "PREFAB_SECURITY_GATE_END")

mod:registerAssetId("models/Security8.fbx/Prefab/Constable.Part.007", "PREFAB_SECURITY_CONSTABLE7")
mod:registerAssetId("models/Security8.fbx/Prefab/Constable.Part.008", "PREFAB_SECURITY_CONSTABLE8")
mod:registerAssetId("models/Security8.fbx/Prefab/Constable.Part.009", "PREFAB_SECURITY_CONSTABLE9")
mod:registerAssetId("models/Security8.fbx/Prefab/Constable.Part.010", "PREFAB_SECURITY_CONSTABLE10")
mod:registerAssetId("models/Security8.fbx/Prefab/Constable.Part.011", "PREFAB_SECURITY_CONSTABLE11")
mod:registerAssetId("models/Security8.fbx/Prefab/Constable.Part.012", "PREFAB_SECURITY_CONSTABLE12")
mod:registerAssetId("models/Security8.fbx/Prefab/Constable.Part.007.Constr", "PREFAB_SECURITY_CONSTABLE7_CONSTR")

mod:registerAssetId("models/Security9.fbx/Prefab/Constable.Part.013", "PREFAB_SECURITY_CONSTABLE13")
mod:registerAssetId("models/Security9.fbx/Prefab/Constable.Part.014", "PREFAB_SECURITY_CONSTABLE14")
mod:registerAssetId("models/Security9.fbx/Prefab/Constable.Part.015", "PREFAB_SECURITY_CONSTABLE15")
mod:registerAssetId("models/Security9.fbx/Prefab/Constable.Part.016", "PREFAB_SECURITY_CONSTABLE16")
mod:registerAssetId("models/Security9.fbx/Prefab/Constable.Part.017", "PREFAB_SECURITY_CONSTABLE17")
mod:registerAssetId("models/Security9.fbx/Prefab/Constable.Part.018", "PREFAB_SECURITY_CONSTABLE18")
mod:registerAssetId("models/Security9.fbx/Prefab/Constable.Part.013.Constr", "PREFAB_SECURITY_CONSTABLE13_CONSTR")



-- Collider Platform -------------------------------------------------------------------------------------
mod:configurePrefabFlagList("models/Security4.fbx/Prefab/Constable.Part.001", { "PLATFORM" })
mod:configurePrefabFlagList("models/Security5.fbx/Prefab/Door.Part.001", { "PLATFORM" })
mod:configurePrefabFlagList("models/Security6.fbx/Prefab/Wall.Part.End.001", { "PLATFORM" })
mod:configurePrefabFlagList("models/Security7.fbx/Prefab/Gate.Part.End.001", { "PLATFORM" })
mod:configurePrefabFlagList("models/Security8.fbx/Prefab/Constable.Part.007", { "PLATFORM" })
mod:configurePrefabFlagList("models/Security9.fbx/Prefab/Constable.Part.013", { "PLATFORM" })



-- Grounding -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Security4.fbx/Prefab/Constable.Part.001/Porch.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/Constable.Part.001/Porch.002", {DataType = "COMP_GROUNDED"})

mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/Tent.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/Tent.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/Tent.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/Baskets.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/Boxes.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/Barrels.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/Campfire.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/FireEmitter.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/FireEmitter.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/SmokeEmitter.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/SparkEmitter.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/SparkEmitter.002", {DataType = "COMP_GROUNDED"})

mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.002/Campfire.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.002/Ashes.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.002/Tent.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.002/Tent.005", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.002/Tent.006", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.002/Tent.007", {DataType = "COMP_GROUNDED"})

mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawTheftPoint.001", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawTheftPoint.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawTheftPoint.003", {DataType = "COMP_GROUNDED"})

mod:registerPrefabComponent("models/Security4.fbx/Prefab/SoldierRally.Part/Campfire.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/SoldierRally.Part/FireEmitter.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/SoldierRally.Part/FireEmitter.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/SoldierRally.Part/SmokeEmitter.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/SoldierRally.Part/SparkEmitter.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/Security4.fbx/Prefab/SoldierRally.Part/SparkEmitter.004", {DataType = "COMP_GROUNDED"})

mod:registerPrefabComponent("models/Security4.fbx/Prefab/Pathfinder", {DataType = "COMP_GROUNDED"})

mod:registerPrefabComponent("models/Security5.fbx/Prefab/Door.Part.001", {DataType = "COMP_GROUNDED"})

for i = 2, 17 do
    mod:registerPrefabComponent("models/Security5.fbx/Prefab/Tower.Part.Round.Root/Attach_Door." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" } )
end

for i = 18, 21 do
    mod:registerPrefabComponent("models/Security5.fbx/Prefab/Tower.Part.Square.Root/Attach_Door." .. string.sub("000" .. i, -3), { DataType = "COMP_GROUNDED" } )
end

mod:registerPrefabComponent("models/Security8.fbx/Prefab/Constable.Part.007/Door.001", {DataType = "COMP_GROUNDED"})

mod:registerPrefabComponent("models/Security9.fbx/Prefab/Constable.Part.013/Door.001", {DataType = "COMP_GROUNDED"})



-- Attach type -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Security5.fbx/Prefab/Door.Part.000", { DataType = "COMP_BUILDING_PART", BuildingPartType = "DOOR" })
mod:registerPrefabComponent("models/Security5.fbx/Prefab/Window.Part.001", { DataType = "COMP_BUILDING_PART", BuildingPartType = "MINOR" })
mod:registerPrefabComponent("models/Security5.fbx/Prefab/Window.Part.002", { DataType = "COMP_BUILDING_PART", BuildingPartType = "MINOR" })

mod:registerPrefabComponent("models/Security5.fbx/Prefab/Door.Part.004", { DataType = "COMP_BUILDING_PART", BuildingPartType = "SIDE" })
mod:registerPrefabComponent("models/Security5.fbx/Prefab/Banner.Part.001", { DataType = "COMP_BUILDING_PART", BuildingPartType = "MINOR" })

mod:registerPrefabComponent("models/Security6.fbx/Prefab/Wall.Part.Root", { DataType = "COMP_BUILDING_PART", BuildingPartType = "MAJOR" })

for i = 1, 2 do
    mod:registerPrefabComponent("models/Security6.fbx/Prefab/Wall.Part.Root/Attach_Major.00" .. i, { 
        DataType = "COMP_BUILDING_ATTACH_NODE",
        AttachNodeTypeList = { "MAJOR" },
        AllowedAngles = {-math.pi, math.pi},
    })
end



-- Dirt circle -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/Campfire.001", {
	DataType = "COMP_DIRT_CIRCLE",
    HardRadius = 3,
    SoftRadius = 4,
})



-- Material -------------------------------------------------------------------------------------
mod:registerAssetId("models/Security4.fbx/Materials/Material.Vine", "MATERIAL_SECURITY_VINE")
mod:overrideAsset({
    Id = "MATERIAL_SECURITY_VINE",
	HasAlphaTest = true,
})

mod:registerAssetId("models/Security4.fbx/Materials/Material.Points.Green", "MATERIAL_SECURITY_POINTS_GREEN")
mod:overrideAsset({
    Id = "MATERIAL_SECURITY_POINTS_GREEN",
    RenderMode = "UNLIT",
	BackFaceVisible = true,
	HasShadow = false
})

mod:registerAssetId("models/Security4.fbx/Materials/Material.BillboardPlus", "MATERIAL_SECURITY_POINTS_PLUS")
mod:overrideAsset({
    Id = "MATERIAL_SECURITY_POINTS_PLUS",
    RenderMode = "UNLIT",
	BackFaceVisible = true,
	HasShadow = false
})

mod:registerAssetId("models/Security4.fbx/Materials/Material.BillboardPlus10", "MATERIAL_SECURITY_POINTS_PLUS10")
mod:overrideAsset({
    Id = "MATERIAL_SECURITY_POINTS_PLUS10",
    RenderMode = "UNLIT",
	BackFaceVisible = true,
	HasShadow = false
})

mod:registerAssetId("models/Security4.fbx/Materials/Material.BillboardPlus5", "MATERIAL_SECURITY_POINTS_PLUS5")
mod:overrideAsset({
    Id = "MATERIAL_SECURITY_POINTS_PLUS5",
    RenderMode = "UNLIT",
	BackFaceVisible = true,
	HasShadow = false
})

mod:registerAssetId("models/Security4.fbx/Materials/Material.BillboardPlus2", "MATERIAL_SECURITY_POINTS_PLUS2")
mod:overrideAsset({
    Id = "MATERIAL_SECURITY_POINTS_PLUS2",
    RenderMode = "UNLIT",
	BackFaceVisible = true,
	HasShadow = false
})

mod:registerAssetId("models/Security4.fbx/Materials/Material.BillboardLow", "MATERIAL_SECURITY_POINTS_LOW")
mod:overrideAsset({
    Id = "MATERIAL_SECURITY_POINTS_LOW",
    RenderMode = "UNLIT",
	BackFaceVisible = true,
	HasShadow = false
})

mod:registerAssetId("models/Security4.fbx/Materials/Material.BillboardMed", "MATERIAL_SECURITY_POINTS_MED")
mod:overrideAsset({
    Id = "MATERIAL_SECURITY_POINTS_MED",
    RenderMode = "UNLIT",
	BackFaceVisible = true,
	HasShadow = false
})

mod:registerAssetId("models/Security4.fbx/Materials/Material.BillboardHigh", "MATERIAL_SECURITY_POINTS_HIGH")
mod:overrideAsset({
    Id = "MATERIAL_SECURITY_POINTS_HIGH",
    RenderMode = "UNLIT",
	BackFaceVisible = true,
	HasShadow = false
})


for i = 4, 9 do
    mod:registerAssetId("models/Security" .. i .. ".fbx/Materials/Material.WallRock5", "MATERIAL_SECURITY_STONE1_" .. i)
    mod:registerAssetId("models/Security" .. i .. ".fbx/Materials/Material.RockWalls", "MATERIAL_SECURITY_STONE2_" .. i)
    mod:registerAssetId("models/Security" .. i .. ".fbx/Materials/Material.WallRock7", "MATERIAL_SECURITY_STONE3_" .. i)
    mod:registerAssetId("models/Security" .. i .. ".fbx/Materials/Material.MortarStone", "MATERIAL_SECURITY_STONE4_" .. i)
    mod:registerAssetId("models/Security" .. i .. ".fbx/Materials/Material.MonasteryRoof", "MATERIAL_SECURITY_ROOF1_" .. i)
    mod:registerAssetId("models/Security" .. i .. ".fbx/Materials/Material.CeramicRoofTiles", "MATERIAL_SECURITY_ROOF2_" .. i)
end

mod:registerAssetId("models/Security4.fbx/Materials/Material.PlanksDark", "MATERIAL_SECURITY_WOOD5")
mod:registerAssetId("models/Security4.fbx/Materials/Material.Planks", "MATERIAL_SECURITY_WOOD6")
mod:registerAssetId("models/Security4.fbx/Materials/Material.TimberWall", "MATERIAL_SECURITY_WOOD7")
mod:registerAssetId("models/Security4.fbx/Materials/Material.WallWood3", "MATERIAL_SECURITY_WOOD8")

mod:registerAssetId("models/Security5.fbx/Materials/Material.TimberWall", "MATERIAL_SECURITY_WOOD1")
mod:registerAssetId("models/Security5.fbx/Materials/Material.WallWood3", "MATERIAL_SECURITY_WOOD2")
mod:registerAssetId("models/Security5.fbx/Materials/Material.WoodenBarricade1", "MATERIAL_SECURITY_WOOD3")
mod:registerAssetId("models/Security5.fbx/Materials/Material.WoodenBarricade2", "MATERIAL_SECURITY_WOOD4")
mod:registerAssetId("models/Security5.fbx/Materials/Material.PlanksDark", "MATERIAL_SECURITY_WOOD9")
mod:registerAssetId("models/Security5.fbx/Materials/Material.Planks", "MATERIAL_SECURITY_WOOD10")



-- Smoke -------------------------------------------------------------------------------------
-- Addition particles for campfire are in particles.lua
mod:registerPrefabComponent("models/Security4.fbx/Prefab/Constable.Part.001/SmokeEmitter.000", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = false,
	IsEmitting = false,
})

mod:registerPrefabComponent("models/Security4.fbx/Prefab/Constable.Part.001/SmokeEmitter.000", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false,
})

mod:registerPrefabComponent("models/Security4.fbx/Prefab/Constable.Part.001", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
        { "PREFAB_SECURITY_CONSTABLE1_SMOKE", "COMP_PARTICLE_EMITTER_TOGGLE" },
	},
})



-- Resource Generator: Security -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_RESOURCE_GENERATOR",
    Id = "BUILDING_FUNCTION_SECURITY_GENERATOR",
    Name = "BUILDING_FUNCTION_SECURITY_GENERATOR_NAME",
    ResourceGenerated = "RESOURCE_SECURITY",
    IsForConsumer = true,
    IsInfinite = false,
})



-- Pathfinder Agent -------------------------------------------------------------------------------------
mod:registerPrefabComponent("PREFAB_SECURITY_PATHFINDER", { DataType = "COMP_AGENT", BehaviorTree = "BEHAVIOR_SECURITY_PATHFINDER" } )
mod:registerPrefabComponent("PREFAB_SECURITY_PATHFINDER", { DataType = "COMP_SECURITY_PATHFINDER" })



-- Other Component registration -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001", { DataType = "COMP_SECURITY_OUTLAWCAMP" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/OutlawPosition.001", { DataType = "COMP_SECURITY_OUTLAWPOSITION" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/OutlawPosition.002", { DataType = "COMP_SECURITY_OUTLAWPOSITION" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/OutlawPosition.003", { DataType = "COMP_SECURITY_OUTLAWPOSITION" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/OutlawPosition.004", { DataType = "COMP_SECURITY_OUTLAWPOSITION" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/OutlawPosition.005", { DataType = "COMP_SECURITY_OUTLAWPOSITION" })

mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/SoldierPosition.001", { DataType = "COMP_SECURITY_SOLDIERPOSITION" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/SoldierPosition.002", { DataType = "COMP_SECURITY_SOLDIERPOSITION" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/SoldierPosition.003", { DataType = "COMP_SECURITY_SOLDIERPOSITION" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/SoldierPosition.004", { DataType = "COMP_SECURITY_SOLDIERPOSITION" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawCamp.001/SoldierPosition.005", { DataType = "COMP_SECURITY_SOLDIERPOSITION" })

mod:registerPrefabComponent("models/Security4.fbx/Prefab/SoldierRally.Part", { DataType = "COMP_SECURITY_RALLY" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/SoldierRally.Part/RallyPosition.001", { DataType = "COMP_SECURITY_RALLYPOSITION" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/SoldierRally.Part/RallyPosition.002", { DataType = "COMP_SECURITY_RALLYPOSITION" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/SoldierRally.Part/RallyPosition.003", { DataType = "COMP_SECURITY_RALLYPOSITION" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/SoldierRally.Part/RallyPosition.004", { DataType = "COMP_SECURITY_RALLYPOSITION" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/SoldierRally.Part/RallyPosition.005", { DataType = "COMP_SECURITY_RALLYPOSITION" })

mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawTheftPoint.001", { DataType = "COMP_SECURITY_OUTLAWTHEFTPOINT" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawTheftPoint.002", { DataType = "COMP_SECURITY_OUTLAWTHEFTPOINT" })
mod:registerPrefabComponent("models/Security4.fbx/Prefab/OutlawTheftPoint.003", { DataType = "COMP_SECURITY_OUTLAWTHEFTPOINT" })



-- Village Center -------------------------------------------------------------------------------------
-- Combine the outlaw camp building part with the village center so that it is ready to use when needed
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_OUTLAWCAMP",
    Name = "BUILDING_PART_SECURITY_OUTLAWCAMP_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_OUTLAWCAMP",
    }, 
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_OUTLAW"
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_VILLAGECENTER_ASSEMBLAGE",
    Name = "BUILDING_PART_SECURITY_VILLAGECENTER_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_SECURITY_VILLAGECENTER" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_VILLAGE_CENTER" },
			{ BuildingPart = "BUILDING_PART_SECURITY_OUTLAWCAMP" },
        },
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_CONSTABLE",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_VILLAGECENTER",
    Name = "BUILDING_PART_SECURITY_VILLAGECENTER_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
            "BUILDING_PART_SECURITY_VILLAGECENTER_ASSEMBLAGE"
        },
    }, 
})

mod:overrideAsset({
    Id = "BUILDING_VILLAGE_CENTER",
    AssetCoreBuildingPart = "BUILDING_PART_SECURITY_VILLAGECENTER",
})



-- Building -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "BUILDING",
	Id = "BUILDING_SECURITY",
	Name = "BUILDING_SECURITY_NAME",
	Description = "BUILDING_SECURITY_DESC",
    BuildingType = "SERVICE",
	AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
    AssetMiniatureBuildingPart = "BUILDING_PART_SECURITY_BANNER",
	BuildingPartSetList = {
		{
			Name = "BUILDING_PART_SETLIST_SECURITY1_NAME",
			BuildingPartList = {
				"BUILDING_PART_SECURITY_CONSTABLEA",
				"BUILDING_PART_SECURITY_CONSTABLEB",
				"BUILDING_PART_SECURITY_CONSTABLEC",
			},
        },
		{
			Name = "BUILDING_PART_SETLIST_SECURITY2_NAME",
			BuildingPartList = {
				"BUILDING_PART_SECURITY_TOWER1",
				"BUILDING_PART_SECURITY_TOWER2",
				"BUILDING_PART_SECURITY_TOWER3",
				"BUILDING_PART_SECURITY_TOWER_DOOR",
				"BUILDING_PART_SECURITY_TOWER4",
				"BUILDING_PART_SECURITY_TOWER5",
				"BUILDING_PART_SECURITY_TOWER6",
				"BUILDING_PART_SECURITY_TOWER_WINDOW1",
				"BUILDING_PART_SECURITY_BANNER",
				"BUILDING_PART_SECURITY_PATROLPOINT",
                "BUILDING_PART_SECURITY_RALLY",
				"BUILDING_PART_SECURITY_TOWER_WINDOW2",
			},
        },
		{
			Name = "BUILDING_PART_SETLIST_SECURITY3_NAME",
			BuildingPartList = { 
				"BUILDING_PART_SECURITY_WALL",
				"BUILDING_PART_SECURITY_GATE",
				"BUILDING_PART_SECURITY_WALL_DOOR",
			},
        },
    },
    VillagerRequired = { Status = "NEWCOMER", Quantity = MinPopUnlock() },
	MaterialSetList = {
		{
			SetName = "MATERIAL_SET_SECURITY1_NAME",
			MaterialList = {
				"MATERIAL_SECURITY_STONE1_4",
				"MATERIAL_SECURITY_STONE1_5",
				"MATERIAL_SECURITY_STONE1_6",
				"MATERIAL_SECURITY_STONE1_7",
				"MATERIAL_SECURITY_STONE1_8",
                "MATERIAL_SECURITY_ROOF1_4",
                "MATERIAL_SECURITY_ROOF1_5",
                "MATERIAL_SECURITY_ROOF1_6",
                "MATERIAL_SECURITY_ROOF1_7",
                "MATERIAL_SECURITY_ROOF1_8",
                "MATERIAL_SECURITY_WOOD1",
                "MATERIAL_SECURITY_WOOD3",
                "MATERIAL_SECURITY_WOOD5",
                "MATERIAL_SECURITY_WOOD7",
                "MATERIAL_SECURITY_WOOD9",
			},
		},
		{
			SetName = "MATERIAL_SET_SECURITY2_NAME",
			MaterialList = {
				"MATERIAL_SECURITY_STONE2_4",
				"MATERIAL_SECURITY_STONE2_5",
				"MATERIAL_SECURITY_STONE2_6",
				"MATERIAL_SECURITY_STONE2_7",
				"MATERIAL_SECURITY_STONE2_8",
                "MATERIAL_SECURITY_ROOF1_4",
                "MATERIAL_SECURITY_ROOF1_5",
                "MATERIAL_SECURITY_ROOF1_6",
                "MATERIAL_SECURITY_ROOF1_7",
                "MATERIAL_SECURITY_ROOF1_8",
                "MATERIAL_SECURITY_WOOD1",
                "MATERIAL_SECURITY_WOOD3",
                "MATERIAL_SECURITY_WOOD5",
                "MATERIAL_SECURITY_WOOD7",
                "MATERIAL_SECURITY_WOOD9",
			},
		},
		{
			SetName = "MATERIAL_SET_SECURITY3_NAME",
			MaterialList = {
				"MATERIAL_SECURITY_STONE3_4",
				"MATERIAL_SECURITY_STONE3_5",
				"MATERIAL_SECURITY_STONE3_6",
				"MATERIAL_SECURITY_STONE3_7",
				"MATERIAL_SECURITY_STONE3_8",
                "MATERIAL_SECURITY_ROOF2_4",
                "MATERIAL_SECURITY_ROOF2_5",
                "MATERIAL_SECURITY_ROOF2_6",
                "MATERIAL_SECURITY_ROOF2_7",
                "MATERIAL_SECURITY_ROOF2_8",
                "MATERIAL_SECURITY_WOOD2", -- round tower top wood part
                "MATERIAL_SECURITY_WOOD4",
                "MATERIAL_SECURITY_WOOD6",
                "MATERIAL_SECURITY_WOOD8",
                "MATERIAL_SECURITY_WOOD10",
			},
		},
		{
			SetName = "MATERIAL_SET_SECURITY4_NAME",
			MaterialList = {
				"MATERIAL_SECURITY_STONE4_4",
				"MATERIAL_SECURITY_STONE4_5",
				"MATERIAL_SECURITY_STONE4_6",
				"MATERIAL_SECURITY_STONE4_7",
				"MATERIAL_SECURITY_STONE4_8",
                "MATERIAL_SECURITY_ROOF2_4",
                "MATERIAL_SECURITY_ROOF2_5",
                "MATERIAL_SECURITY_ROOF2_6",
                "MATERIAL_SECURITY_ROOF2_7",
                "MATERIAL_SECURITY_ROOF2_8",
                "MATERIAL_SECURITY_WOOD2", -- round tower top wood part
                "MATERIAL_SECURITY_WOOD4",
                "MATERIAL_SECURITY_WOOD6",
                "MATERIAL_SECURITY_WOOD8",
                "MATERIAL_SECURITY_WOOD10",
			},
		},
    },
})



-- Building Part: Constable A -------------------------------------------------------------------------------------
local polyConstable = { -- y, x     Facing x in Blender: y increases going left, x increases going down
    { -3, -3 },
    { 3, -3 },
    { 3, -2 },
    { 4.0, -2 },
    { 4.0, 2 },
    { 3, 2 },
    { 3, 3 },

    { -0.5, 3 },
	{ -1, 3.5 },
	{ -1.4, 3.7 },
	{ -1.4, 5 },
	{ -3.5, 5 },

    { -5.0, 4.0 },
	{ -5.5, 1.5 },
	{ -5, 0 },
	{ -4.3, -1 },
	{ -4.3, -3.2 },
	{ -2.8, -3.2 },
	{ -2.8, -3 },
}

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE1",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE1",
    },
    ConstructionVisual = "PREFAB_SECURITY_CONSTABLE1_CONSTR",
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_CONSTABLE",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE2",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE2",
    }, 
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD1",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE3",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE3",
    }, 
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD1",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE4",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE4",
    }, 
    -- AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GENERATOR",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE5",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE5",
    }, 
    -- AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GENERATOR",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE6",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE6",
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_PRISON",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLEA_ASSEMBLAGE",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_SECURITY_CONSTABLE0" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE1" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE2" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE3" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE4" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE5" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE6" },
        },
    }, 
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLEA",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
            "BUILDING_PART_SECURITY_CONSTABLEA_ASSEMBLAGE"
        },
        -- MiniatureConfig = {
        --     ClipUnderGround = true,
        --     GroupHeight = 0.0,
        --     CameraPosition = { -0.5, 8, -27 },
        --     OrientationOffset = 105.0,
        --     CameraPitchOffset = 0.0,
        -- },
    },
    BuildingZone = {
        ZoneEntryList = {
            { 
                Polygon = polyConstable,
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
            },
        }
    },
    Cost = {
        BuildRightTaxes = {
            { Resource = "GOLD_COINS", Quantity = 50 }
        },
        UpkeepCost = { 
            { Resource = "GOLD_COINS", Quantity = 15 }
        },
        ResourceNeededList = {
            {
                { Resource = "STONE", Quantity = 5 },
                { Resource = "POLISHED_STONE", Quantity = 10 },
            },
            {
                { Resource = "POLISHED_STONE", Quantity = 10 },
                { Resource = "WOOD", Quantity = 10 },
            },
            {
                { Resource = "POLISHED_STONE", Quantity = 5 },
                { Resource = "PLANK", Quantity = 10 },
            },
            {
                { Resource = "TOOL", Quantity = 4 },
            },
        },
    },
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "ADD",
		Radius = 50.0,
		Value = 0.5
	} },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GENERATOR",
})



-- Building Part: Constable B -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE7",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE7",
    },
    ConstructionVisual = "PREFAB_SECURITY_CONSTABLE7_CONSTR",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE8",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE8",
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_CONSTABLE",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE9",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE9",
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD1",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE10",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE10",
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD1",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE11",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE11",
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD1",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE12",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE12",
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_PRISON",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLEB_ASSEMBLAGE",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_SECURITY_CONSTABLE0" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE7" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE8" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE9" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE10" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE11" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE12" },
        },
    },
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLEB",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
            "BUILDING_PART_SECURITY_CONSTABLEB_ASSEMBLAGE"
        },
        -- MiniatureConfig = {
        --     ClipUnderGround = true,
        --     GroupHeight = 0.0,
        --     CameraPosition = { -0.5, 8, -27 },
        --     OrientationOffset = 105.0,
        --     CameraPitchOffset = 0.0,
        -- },
    },
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createRectangle( {10, 10}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
            },
            {
                Polygon = polygon.createRectangle( {3, 3}, {4.0, 4.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
            },
            {
                Polygon = polygon.createRectangle( {3, 3}, {4.0, -4.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
            },
            {
                Polygon = polygon.createRectangle( {3, 3}, {-4.0, 4.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
            },
            {
                Polygon = polygon.createRectangle( {3, 3}, {-4.0, -4.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
            },
        }
    },
    Cost = {
        BuildRightTaxes = {
            { Resource = "GOLD_COINS", Quantity = 70 }
        },
        UpkeepCost = { 
            { Resource = "GOLD_COINS", Quantity = 25 }
        },
        ResourceNeededList = {
            {
                { Resource = "STONE", Quantity = 10 },
                { Resource = "POLISHED_STONE", Quantity = 10 },
            },
            {
                { Resource = "STONE", Quantity = 10 },
                { Resource = "POLISHED_STONE", Quantity = 10 },
            },
            {
                { Resource = "STONE", Quantity = 5 },
                { Resource = "POLISHED_STONE", Quantity = 10 },
                { Resource = "WOOD", Quantity = 5 },
            },
            {
                { Resource = "POLISHED_STONE", Quantity = 5 },
                { Resource = "WOOD", Quantity = 10 },
                { Resource = "PLANK", Quantity = 5 },
            },
            {
                { Resource = "PLANK", Quantity = 5 },
                { Resource = "TOOL", Quantity = 5 },
            },
        },
    },
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "ADD",
		Radius = 70.0,
		Value = 0.5
	} },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GENERATOR",
})



-- Building Part: Constable C -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE13",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE13",
    },
    ConstructionVisual = "PREFAB_SECURITY_CONSTABLE13_CONSTR",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE14",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE14",
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_CONSTABLE",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE15",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE15",
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD1",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE16",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE16",
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD1",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE17",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE17",
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD1",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLE18",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_CONSTABLE18",
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_PRISON",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLEC_ASSEMBLAGE",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_SECURITY_CONSTABLE0" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE13" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE14" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE15" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE16" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE17" },
			{ BuildingPart = "BUILDING_PART_SECURITY_CONSTABLE18" },
        },
    },
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_CONSTABLEC",
    Name = "BUILDING_PART_SECURITY_CONSTABLE_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
            "BUILDING_PART_SECURITY_CONSTABLEC_ASSEMBLAGE"
        },
        -- MiniatureConfig = {
        --     ClipUnderGround = true,
        --     GroupHeight = 0.0,
        --     CameraPosition = { -0.5, 8, -27 },
        --     OrientationOffset = 105.0,
        --     CameraPitchOffset = 0.0,
        -- },
    },
    BuildingZone = {
        ZoneEntryList = {
            {
                Polygon = polygon.createCircle( 7.25, {0.0, 0.0}, 32 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
            },
        }
    },
    Cost = {
        BuildRightTaxes = {
            { Resource = "GOLD_COINS", Quantity = 100 }
        },
        UpkeepCost = { 
            { Resource = "GOLD_COINS", Quantity = 50 }
        },
        ResourceNeededList = {
            {
                { Resource = "STONE", Quantity = 20 },
                { Resource = "POLISHED_STONE", Quantity = 20 },
            },
            {
                { Resource = "STONE", Quantity = 20 },
                { Resource = "POLISHED_STONE", Quantity = 20 },
            },
            {
                { Resource = "POLISHED_STONE", Quantity = 20 },
                { Resource = "WOOD", Quantity = 20 },
            },
            {
                { Resource = "POLISHED_STONE", Quantity = 20 },
                { Resource = "WOOD", Quantity = 20 },
            },
            {
                { Resource = "PLANK", Quantity = 20 },
                { Resource = "TOOL", Quantity = 10 },
            },
        },
    },
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "ADD",
		Radius = 90.0,
		Value = 0.5
	} },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GENERATOR",
})



-- Building Function: Constable -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_SECURITY_CONSTABLE",
	Name = "BUILDING_FUNCTION_SECURITY_CONSTABLE_NAME",
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_SECURITY_CONSTABLE",
        Behavior = "BEHAVIOR_WORK"
	},
	InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_SECURITY", Quantity = 0 },
	}
})



-- Job: Constable -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "JOB",
	Id = "JOB_SECURITY_CONSTABLE",
	JobName = "JOB_SECURITY_CONSTABLE_NAME",
	JobDescription = "JOB_SECURITY_CONSTABLE_DESC",
	IsLockedByDefault = false,
    Hidden = false,
	DefaultBehavior = "BEHAVIOR_WORK",
    ProductionDelay = 30.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
        RightHandObject = {
			DataType = "HAND_OBJECT",
            Model = "PREFAB_TOOL_ENVOY_SCROLL"
        },
        FemaleFrontList = {
            "PREFAB_SECURITY_CONSTABLEFEMALE_FRONT1",
        }, 
        MaleFrontList = {
            "PREFAB_SECURITY_CONSTABLEMALE_FRONT1",
        }, 
        FemaleHatList = {
            "PREFAB_SECURITY_CONSTABLEFEMALE_HAT1",
        }, 
        MaleHatList = {
            "PREFAB_SECURITY_CONSTABLEMALE_HAT1",
        }, 
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:overrideAsset({ Id = "NEWCOMER", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_CONSTABLE" } })
mod:overrideAsset({ Id = "SERF", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_CONSTABLE" } })
mod:overrideAsset({ Id = "COMMONER", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_CONSTABLE" } })
mod:overrideAsset({ Id = "CITIZEN", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_CONSTABLE" } })




-- Building Part: Tower -------------------------------------------------------------------------------------

mod:registerAsset({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_SECURITY_TOWER_TILING",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_SECURITY_TOWER_TILING"
	},
})

-- round tower
for i = 1, 3 do

    mod:registerAsset({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_SECURITY_TOWER" .. i .. "_END",
        Name = "BUILDING_PART_SECURITY_TOWER_NAME", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_SECURITY_TOWER" .. i .. "_END",
        }, 
        BuildingZone = { 
            ZoneEntryList = {
                { 
                    Polygon = polygon.createCircle( 2.0, {0.0, 0.0}, 16 ),
                    Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
                },
            }
        },
        Cost = {
            BuildRightTaxes = {
                { Resource = "GOLD_COINS", Quantity = 10 }
            },
            UpkeepCost = { 
                { Resource = "GOLD_COINS", Quantity = 5 }
            },
            ResourceNeededList = {
                {
                    { Resource = "STONE", Quantity = 2 },
                    { Resource = "POLISHED_STONE", Quantity = 8 },
                    { Resource = "WOOD", Quantity = 4 },
                    { Resource = "PLANK", Quantity = 4 },
                },
            },
        },
        DesirabilityModifiers = { {
            Desirability = "DESIRABILITY_RESIDENTIAL",
            Type = "ADD",
            Radius = 25.0,
            Value = 0.5
        } }
        })

    mod:registerAsset({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_SECURITY_TOWER" .. i,
        Name = "BUILDING_PART_SECURITY_TOWER_NAME",
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_SCALER",
            CoreObjectPrefab = "PREFAB_SECURITY_TOWER_ROUND_ROOT",
            EndPart = "BUILDING_PART_SECURITY_TOWER" .. i .. "_END",
            FillerList = {
                "BUILDING_PART_SECURITY_TOWER_TILING",
            },
            MinimumScale = 0,
            IsVertical = true,
        },
        AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GENERATOR",
    })

end

-- square tower
for i = 4, 6 do

    mod:registerAsset({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_SECURITY_TOWER" .. i .. "_END",
        Name = "BUILDING_PART_SECURITY_TOWER_NAME",
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_SECURITY_TOWER" .. i .. "_END",
        }, 
        BuildingZone = { 
            ZoneEntryList = {
                { 
                    Polygon = polygon.createRectangle( {4.0, 4.0}, {0.0, 0.0} ),
                    Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
                },
            }
        },
        Cost = {
            BuildRightTaxes = {
                { Resource = "GOLD_COINS", Quantity = 10 }
            },
            UpkeepCost = { 
                { Resource = "GOLD_COINS", Quantity = 5 }
            },
            ResourceNeededList = {
                {
                    { Resource = "STONE", Quantity = 2 },
                    { Resource = "POLISHED_STONE", Quantity = 8 },
                    { Resource = "WOOD", Quantity = 4 },
                    { Resource = "PLANK", Quantity = 4 },
                },
            },
        },
            DesirabilityModifiers = { {
            Desirability = "DESIRABILITY_RESIDENTIAL",
            Type = "ADD",
            Radius = 25.0,
            Value = 0.5
        } }
        })

    mod:registerAsset({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_SECURITY_TOWER" .. i,
        Name = "BUILDING_PART_SECURITY_TOWER_NAME",
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_SCALER",
            CoreObjectPrefab = "PREFAB_SECURITY_TOWER_SQUARE_ROOT",
            EndPart = "BUILDING_PART_SECURITY_TOWER" .. i .. "_END",
            FillerList = {
                "BUILDING_PART_SECURITY_TOWER_TILING",
            },
            MinimumScale = 0,
            IsVertical = true,
        },
        AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GENERATOR",
    })

end



-- Building Part: Tower Door -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_TOWER_DOOR1",
    Name = "BUILDING_PART_SECURITY_TOWER_DOOR_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_TOWER_DOOR1",
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD2",
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_TOWER_DOOR2",
    Name = "BUILDING_PART_SECURITY_TOWER_DOOR_NAME", 
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_TOWER_DOOR2",
    },
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_TOWER_DOOR_ASSEMBLAGE",
    Name = "BUILDING_PART_SECURITY_TOWER_DOOR_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_ASSEMBLAGE",
		CoreRandomBuildingPartList = { "PREFAB_SECURITY_TOWER_DOOR0" },
		MandatoryBuildingPartList = {
			{ BuildingPart = "BUILDING_PART_SECURITY_TOWER_DOOR1" },
			{ BuildingPart = "BUILDING_PART_SECURITY_TOWER_DOOR2" },
        },
    },
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_TOWER_DOOR",
    Name = "BUILDING_PART_SECURITY_TOWER_DOOR_NAME",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_RANDOM_PART",
		RandomPartList = {
            "BUILDING_PART_SECURITY_TOWER_DOOR_ASSEMBLAGE"
        },
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 0.0,
        },
    },
    BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.1, 0.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
        }
    }, 
    Cost = {
        UpkeepCost = {
            { Resource = "GOLD_COINS", Quantity = 2 }
        },
        ResourceNeededList = {
            {
                { Resource = "PLANK", Quantity = 2 },
                { Resource = "TOOL", Quantity = 2 },
            },
        },
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GENERATOR",
})



-- Building Part: Patrol Point -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_PATROLPOINT",
    Name = "BUILDING_PART_SECURITY_PATROLPOINT_NAME",
    Description = "BUILDING_PART_SECURITY_PATROLPOINT_DESC",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_PATROLPOINT",
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 25.0,
        },
    },
	BuildingZone = {
	},
	IsVisibleWhenBuilt = false,
	IsMovableWhenBuilt = true,
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GENERATOR",
})



-- Building Part: Banner -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_BANNER",
    Name = "BUILDING_PART_SECURITY_BANNER_NAME", 
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_BANNER1",
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 0.0,
        },
    }, 
    Cost = {
        ResourceNeededList = {
            {
                { Resource = "WOOLEN_CLOTH", Quantity = 2 },
            },
        },
    },
})



-- Building Function: Guard1 -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_SECURITY_GUARD1",
	Name = "BUILDING_FUNCTION_SECURITY_GUARD_NAME",
    WorkerCapacity = 1,
    RelatedJob = {
        Job = "JOB_SECURITY_GUARD",
        Behavior = "BEHAVIOR_SECURITY_GUARD"
	},
	InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
    ResourceProduced = {
		{ Resource = "RESOURCE_SECURITY", Quantity = 0 },
	}
})



-- Building Function: Guard2 -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_SECURITY_GUARD2",
	Name = "BUILDING_FUNCTION_SECURITY_GUARD_NAME",
    WorkerCapacity = 2,
    RelatedJob = { 
        Job = "JOB_SECURITY_GUARD", 
        Behavior = "BEHAVIOR_SECURITY_GUARD"
	},
	InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_SECURITY", Quantity = 0 },
	}
})



-- Job: Guard -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "JOB",
	Id = "JOB_SECURITY_GUARD",
	JobName = "JOB_SECURITY_GUARD_NAME",
	JobDescription = "JOB_SECURITY_GUARD_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_SECURITY_GUARD",
    ProductionDelay = 40.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP",
        RightHandObject = {
			DataType = "HAND_OBJECT",
            Model = "PREFAB_TOOL_GUARD_SPEAR"
        },
        FemaleFrontList = {
            "PREFAB_SECURITY_GUARDFEMALE_FRONT1",
            "PREFAB_SECURITY_GUARDFEMALE_FRONT2",
        }, 
        FemaleHatList = {
            "PREFAB_SECURITY_GUARDFEMALE_HAT1",
            "PREFAB_SECURITY_GUARDFEMALE_HAT2",
        }, 
        MaleFrontList = {
            "PREFAB_SECURITY_GUARDMALE_FRONT1",
            "PREFAB_SECURITY_GUARDMALE_FRONT2",
            "PREFAB_SECURITY_GUARDMALE_FRONT3",
        }, 
        MaleHatList = {
            "PREFAB_SECURITY_GUARDMALE_HAT1",
            "PREFAB_SECURITY_GUARDMALE_HAT2",
        }, 
		WalkAnimation = "WALK_SPEAR",
		IdleAnimation = "GUARD"
	}
})

mod:overrideAsset({ Id = "NEWCOMER", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_GUARD" } })
mod:overrideAsset({ Id = "SERF", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_GUARD" } })
mod:overrideAsset({ Id = "COMMONER", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_GUARD" } })



-- Building Part: Window -------------------------------------------------------------------------------------
for i = 1, 2 do
    mod:registerAsset({
        DataType = "BUILDING_PART",
        Id = "BUILDING_PART_SECURITY_TOWER_WINDOW" .. i,
        Name = "BUILDING_PART_SECURITY_TOWER_WINDOW_NAME", 
        ConstructorData = {
            DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
            CoreObjectPrefab = "PREFAB_SECURITY_TOWER_WINDOW" .. i,
            MiniatureConfig = {
                ClipUnderGround = false,
                GroupHeight = 0.0,
                CameraPosition = { 0, 0, 0 },
                OrientationOffset = 0.0,
                CameraPitchOffset = 0.0,
            },
        },
        Cost = {
            ResourceNeededList = {
                {
                    { Resource = "POLISHED_STONE", Quantity = 1 },
                },
            },
        },
    })
end



-- Building Part: Wall -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_WALL_END",
    Name = "BUILDING_PART_SECURITY_WALL_NAME", 
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_WALL_END",
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 0.0,
        },
    }, 
    BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {10, 2}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
        }
    },
    Cost = {
        BuildRightTaxes = {
            { Resource = "GOLD_COINS", Quantity = 5 }
        },
        UpkeepCost = { 
            { Resource = "GOLD_COINS", Quantity = 5 }
        },
        ResourceNeededList = {
            {
                { Resource = "STONE", Quantity = 15 },
                { Resource = "POLISHED_STONE", Quantity = 15 },
                { Resource = "TOOL", Quantity = 1 },
            },
        },
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD1",
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "ADD",
		Radius = 25.0,
		Value = 0.5
	} }
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_WALL",
    Name = "BUILDING_PART_SECURITY_WALL_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_SCALER",
        CoreObjectPrefab = "PREFAB_SECURITY_WALL_ROOT",
        EndPart = "BUILDING_PART_SECURITY_WALL_END",
        FillerList = {
            "BUILDING_PART_SECURITY_TOWER_TILING",
        },
        MinimumScale = 0,
        IsVertical = true
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GENERATOR",
})



-- Building Part: Gate -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_GATE_END",
    Name = "BUILDING_PART_SECURITY_GATE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_GATE_END",
        MiniatureConfig = {
            ClipUnderGround = true,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 0.0,
        },
    }, 
    BuildingZone = {
        ZoneEntryList = {
            -- { 
            --     Polygon = polygon.createRectangle( {10, 2}, {0, 0.0} ),
            --     Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = false }
            -- },
            { 
                Polygon = polygon.createRectangle( {3.65, 2}, {-3.3, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
            },
            { 
                Polygon = polygon.createRectangle( {3.65, 2}, {3.3, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
            },
        }
    },
    Cost = {
        BuildRightTaxes = {
            { Resource = "GOLD_COINS", Quantity = 5 }
        },
        UpkeepCost = { 
            { Resource = "GOLD_COINS", Quantity = 5 }
        },
        ResourceNeededList = {
            {
                { Resource = "STONE", Quantity = 10 },
                { Resource = "POLISHED_STONE", Quantity = 10 },
                { Resource = "WOOD", Quantity = 2 },
                { Resource = "TOOL", Quantity = 5 },
            },
        },
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GUARD1",
	DesirabilityModifiers = { {
		Desirability = "DESIRABILITY_RESIDENTIAL",
		Type = "ADD",
		Radius = 25.0,
		Value = 0.5
	} }
})

mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_GATE",
    Name = "BUILDING_PART_SECURITY_GATE_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_SCALER",
        CoreObjectPrefab = "PREFAB_SECURITY_WALL_ROOT",
        EndPart = "BUILDING_PART_SECURITY_GATE_END",
        FillerList = {
            "BUILDING_PART_SECURITY_TOWER_TILING",
        },
        MinimumScale = 0,
        IsVertical = true
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_GENERATOR",
})



-- Building Part: Wall Door -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_WALL_DOOR",
    Name = "BUILDING_PART_SECURITY_WALL_DOOR_NAME", 
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_WALL_DOOR1",
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 0.0,
        },
    },
    BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.1, 0.5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
            },
        }
    },
    Cost = {
        ResourceNeededList = {
            {
                { Resource = "PLANK", Quantity = 2 },
            },
        },
    },
})



-- Building Function: Outlaw -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_SECURITY_OUTLAW",
	Name = "BUILDING_FUNCTION_SECURITY_OUTLAW_NAME",
    IsInfiniteCapacity = true,
    IsPrivate = true,
    HasResourceDepot = false,
    RelatedJob = { 
        Job = "JOB_SECURITY_OUTLAW",
        Behavior = "BEHAVIOR_SECURITY_OUTLAW",
	},
})



-- Job: Outlaw -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "JOB",
	Id = "JOB_SECURITY_OUTLAW",
	JobName = "JOB_SECURITY_OUTLAW_NAME",
	JobDescription = "JOB_SECURITY_OUTLAW_DESC",
	IsLockedByDefault = true,
    Hidden = true,
	DefaultBehavior = "BEHAVIOR_SECURITY_OUTLAW",
    ProductionDelay = 30.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
        RightHandObject = {
			DataType = "HAND_OBJECT",
            Model = "PREFAB_SECURITY_OUTLAW_STAFF"
        },
        FemaleFrontList = {
            "PREFAB_SECURITY_OUTLAWFEMALE_FRONT1",
        },
        MaleFrontList = {
            "PREFAB_SECURITY_OUTLAWMALE_FRONT1",
        },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:overrideAsset({ Id = "NEWCOMER", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_OUTLAW" } })



-- Building Part: Soldier Rally Point -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_PART",
    Id = "BUILDING_PART_SECURITY_RALLY",
    Name = "BUILDING_PART_SECURITY_RALLY_NAME",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = "PREFAB_SECURITY_RALLY",
        MiniatureConfig = {
            ClipUnderGround = false,
            GroupHeight = 0.0,
            CameraPosition = { 0, 0, 0 },
            OrientationOffset = 0.0,
            CameraPitchOffset = 25.0,
        },
    },
    AssetBuildingFunction = "BUILDING_FUNCTION_SECURITY_RALLY",
    BuildingZone = {
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 2.5, {0.0, 0.0}, 16 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true }
            },
        }
    },
    Cost = {
        BuildRightTaxes = {
            { Resource = "GOLD_COINS", Quantity = 50 }
        },
        UpkeepCost = { 
            { Resource = "GOLD_COINS", Quantity = 25 }
        },
        ResourceNeededList = {
            {
                { Resource = "WOOD", Quantity = 2 },
                { Resource = "TOOL", Quantity = 5 },
            },
        },
    },
})



-- Building Function: Rally -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_SECURITY_RALLY",
	Name = "BUILDING_FUNCTION_SECURITY_RALLY_NAME",
    WorkerCapacity = 5,
    RelatedJob = {
        Job = "JOB_SECURITY_GUARD",
        Behavior = "BEHAVIOR_SECURITY_RALLY"
	},
    UpkeepPerWorker = {
        {
            Resource = "GOLD_COINS",
            Quantity = 5,
        },
    },
	InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_SECURITY", Quantity = 0 },
	}
})



-- Building Function: Prison (Infinite) -------------------------------------------------------------------------------------
mod:registerAsset({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_SECURITY_PRISON",
	Name = "BUILDING_FUNCTION_SECURITY_PRISON_NAME",
    IsInfiniteCapacity = true,
    IsPrivate = true,
    IsPausable = false,
    HasResourceDepot = false,
    -- RandomWorkstationReservation = true,
    RelatedJob = {
        Job = "JOB_SECURITY_PRISONER",
        Behavior = "BEHAVIOR_SECURITY_PRISONER",
	},
})



-- Job: Prisoner -------------------------------------------------------------------------------------
mod:registerAsset({
	DataType = "JOB",
	Id = "JOB_SECURITY_PRISONER",
	JobName = "JOB_SECURITY_PRISONER_NAME",
	JobDescription = "JOB_SECURITY_PRISONER_DESC",
	IsLockedByDefault = true,
    Hidden = true,
	DefaultBehavior = "BEHAVIOR_SECURITY_PRISONER",
    ProductionDelay = (60 * 5),
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
        DataType = "CHARACTER_SETUP",
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:overrideAsset({ Id = "NEWCOMER", CompatibleJobList = { Action = "APPEND", "JOB_SECURITY_PRISONER" } })


